com.amazon.redshift.jdbc

## Class RedshiftResultSet

- java.lang.Object
- - com.amazon.redshift.jdbc.RedshiftResultSet

All Implemented Interfaces:
  RedshiftRefCursorResultSet, AutoCloseable, ResultSet, Wrapper

    public class RedshiftResultSet
    extends Object
    implements ResultSet, RedshiftRefCursorResultSet

### Nested Class Summary

Nested Classes
`class` `RedshiftResultSet.CursorResultHandler`

### Field Summary

Fields
`protected BaseConnection` `connection`
`protected int` `currentRow`
`protected ResultCursor` `cursor`
`protected int` `fetchSize`
`protected Field[]` `fields`
`protected int` `maxFieldSize`
`protected int` `maxRows`
`protected boolean` `onInsertRow`
`protected Query` `originalQuery`
`protected RedshiftRowsBlockingQueue<Tuple>` `queueRows`
`protected Thread` `ringBufferThread`
`protected int[]` `rowCount`
`protected int` `rowOffset`
`protected List<Tuple>` `rows`
`protected BaseStatement` `statement`
`protected Tuple` `thisRow`
`protected SQLWarning` `warnings`
`protected boolean` `wasNullFlag` True if the last obtained column value was SQL NULL as specified by `wasNull()`.

### Fields inherited from interface java.sql.ResultSet

`CLOSE_CURSORS_AT_COMMIT, CONCUR_READ_ONLY, CONCUR_UPDATABLE, FETCH_FORWARD, FETCH_REVERSE, FETCH_UNKNOWN, HOLD_CURSORS_OVER_COMMIT, TYPE_FORWARD_ONLY, TYPE_SCROLL_INSENSITIVE, TYPE_SCROLL_SENSITIVE`

### Method Summary

Methods
`boolean` `absolute(int index)`
`protected void` `addWarning(SQLWarning warnings)`
`void` `afterLast()`
`void` `beforeFirst()`
`void` `cancelRowUpdates()`
`protected void` `checkClosed()`
`protected void` `checkColumnIndex(int column)`
`protected void` `checkResultSet(int column)` Checks that the result set is not closed, it's positioned on a valid row and that the given column number is valid.
`void` `clearWarnings()`
`void` `close()`
`protected void` `closeInternally()`
`static Map<String,Integer>` `createColumnNameIndexMap(Field[] fields, boolean isSanitiserDisabled)`
`protected ResultSetMetaData` `createMetaData()`
`void` `deleteRow()`
`int` `findColumn(String columnName)`
`boolean` `first()`
`Array` `getArray(int i)`
`Array` `getArray(String colName)`
`InputStream` `getAsciiStream(int columnIndex)`
`InputStream` `getAsciiStream(String columnName)`
`BigDecimal` `getBigDecimal(int columnIndex)`
`BigDecimal` `getBigDecimal(int columnIndex, int scale)`
`BigDecimal` `getBigDecimal(String columnName)`
`BigDecimal` `getBigDecimal(String columnName, int scale)`
`InputStream` `getBinaryStream(int columnIndex)`
`InputStream` `getBinaryStream(String columnName)`
`Blob` `getBlob(int i)`
`Blob` `getBlob(String columnName)`
`boolean` `getBoolean(int columnIndex)` Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.
`boolean` `getBoolean(String columnName)`
`byte` `getByte(int columnIndex)`
`byte` `getByte(String columnName)`
`byte[]` `getBytes(int columnIndex)`
`byte[]` `getBytes(String columnName)`
`Reader` `getCharacterStream(int i)`
`Reader` `getCharacterStream(String columnName)`
`Clob` `getClob(int i)`
`Clob` `getClob(String columnName)`
`int` `getColumnOID(int field)` Returns the OID of a field.
`int` `getConcurrency()`
`String` `getCursorName()`
`Date` `getDate(int columnIndex)`
`Date` `getDate(int i, Calendar cal)`
`Date` `getDate(String columnName)`
`Date` `getDate(String c, Calendar cal)`
`double` `getDouble(int columnIndex)`
`double` `getDouble(String columnName)`
`int` `getFetchDirection()`
`int` `getFetchSize()`
`String` `getFixedString(int col)` This is used to fix get*() methods on Money fields.
`float` `getFloat(int columnIndex)`
`float` `getFloat(String columnName)`
`int` `getHoldability()`
`int` `getInt(int columnIndex)`
`int` `getInt(String columnName)`
`long` `getLong(int columnIndex)`
`long` `getLong(String columnName)`
`ResultSetMetaData` `getMetaData()`
`Reader` `getNCharacterStream(int columnIndex)`
`Reader` `getNCharacterStream(String columnName)`
`NClob` `getNClob(int columnIndex)`
`NClob` `getNClob(String columnName)`
`String` `getNString(int columnIndex)`
`String` `getNString(String columnName)`
`Object` `getObject(int columnIndex)`
`<T> T` `getObject(int columnIndex, Class<T> type)`
`Object` `getObject(int i, Map<String,Class<?>> map)`
`Object` `getObject(String columnName)`
`<T> T` `getObject(String columnLabel, Class<T> type)`
`Object` `getObject(String s, Map<String,Class<?>> map)`
`Object` `getObjectImpl(int i, Map<String,Class<?>> map)`
`Object` `getObjectImpl(String columnName, Map<String,Class<?>> map)`
`BaseStatement` `getRedshiftStatement()`
`Ref` `getRef(int i)`
`Ref` `getRef(String columnName)`
`String` `getRefCursor()`
`int` `getRow()`
`long` `getRowCount()` Returns the number of rows in the result set.
`RowId` `getRowId(int columnIndex)`
`RowId` `getRowId(String columnName)`
`protected String` `getRSType(int column)`
`short` `getShort(int columnIndex)`
`short` `getShort(String columnName)`
`protected int` `getSQLType(int column)`
`SQLXML` `getSQLXML(int columnIndex)`
`SQLXML` `getSQLXML(String columnName)`
`Statement` `getStatement()`
`String` `getString(int columnIndex)`
`String` `getString(String columnName)`
`Time` `getTime(int columnIndex)`
`Time` `getTime(int i, Calendar cal)`
`Time` `getTime(String columnName)`
`Time` `getTime(String c, Calendar cal)`
`Timestamp` `getTimestamp(int columnIndex)`
`Timestamp` `getTimestamp(int i, Calendar cal)`
`Timestamp` `getTimestamp(String columnName)`
`Timestamp` `getTimestamp(String c, Calendar cal)`
`int` `getType()`
`InputStream` `getUnicodeStream(int columnIndex)`
`InputStream` `getUnicodeStream(String columnName)`
`URL` `getURL(int columnIndex)`
`URL` `getURL(String columnName)`
`protected Object` `getUUID(byte[] data)`
`protected Object` `getUUID(String data)`
`SQLWarning` `getWarnings()`
`void` `insertRow()`
`protected Object` `internalGetObject(int columnIndex, Field field)`
`boolean` `isAfterLast()`
`boolean` `isBeforeFirst()`
`protected boolean` `isBinary(int column)` Returns true if the value of the given column is in binary format.
`boolean` `isClosed()`
`boolean` `isFirst()`
`protected boolean` `isGeography(int column)`
`protected boolean` `isGeometry(int column)`
`protected boolean` `isGeometryHex(int column)`
`protected boolean` `isInterval(int column)`
`boolean` `isLast()`
`protected boolean` `isResultSetClosed()`
`protected boolean` `isSuper(int column)`
`protected boolean` `isVarbyte(int column)`
`boolean` `isWrapperFor(Class<?> iface)`
`boolean` `last()`
`protected Array` `makeArray(int oid, byte[] value)`
`protected Array` `makeArray(int oid, String value)`
`protected Blob` `makeBlob(long oid)`
`protected Clob` `makeClob(long oid)`
`void` `moveToCurrentRow()`
`void` `moveToInsertRow()`
`boolean` `next()`
`boolean` `previous()`
`static String[]` `quotelessTableName(String fullname)` Cracks out the table name and schema (if it exists) from a fully qualified table name.
`void` `refreshRow()`
`boolean` `relative(int rows)`
`boolean` `rowDeleted()`
`boolean` `rowInserted()`
`boolean` `rowUpdated()`
`void` `setFetchDirection(int direction)`
`void` `setFetchSize(int rows)`
`static BigDecimal` `toBigDecimal(String s)`
`BigDecimal` `toBigDecimal(String s, int scale)`
`static double` `toDouble(String s)`
`static float` `toFloat(String s)`
`static int` `toInt(String s)`
`static long` `toLong(String s)`
`static short` `toShort(String s)`
`<T> T` `unwrap(Class<T> iface)`
`void` `updateArray(int columnIndex, Array x)`
`void` `updateArray(String columnName, Array x)`
`void` `updateAsciiStream(int columnIndex, InputStream inputStream)`
`void` `updateAsciiStream(int columnIndex, InputStream x, int length)`
`void` `updateAsciiStream(int columnIndex, InputStream inputStream, long length)`
`void` `updateAsciiStream(String columnName, InputStream inputStream)`
`void` `updateAsciiStream(String columnName, InputStream x, int length)`
`void` `updateAsciiStream(String columnName, InputStream inputStream, long length)`
`void` `updateBigDecimal(int columnIndex, BigDecimal x)`
`void` `updateBigDecimal(String columnName, BigDecimal x)`
`void` `updateBinaryStream(int columnIndex, InputStream inputStream)`
`void` `updateBinaryStream(int columnIndex, InputStream x, int length)`
`void` `updateBinaryStream(int columnIndex, InputStream inputStream, long length)`
`void` `updateBinaryStream(String columnName, InputStream inputStream)`
`void` `updateBinaryStream(String columnName, InputStream x, int length)`
`void` `updateBinaryStream(String columnName, InputStream inputStream, long length)`
`void` `updateBlob(int columnIndex, Blob x)`
`void` `updateBlob(int columnIndex, InputStream inputStream)`
`void` `updateBlob(int columnIndex, InputStream inputStream, long length)`
`void` `updateBlob(String columnName, Blob x)`
`void` `updateBlob(String columnName, InputStream inputStream)`
`void` `updateBlob(String columnName, InputStream inputStream, long length)`
`void` `updateBoolean(int columnIndex, boolean x)`
`void` `updateBoolean(String columnName, boolean x)`
`void` `updateByte(int columnIndex, byte x)`
`void` `updateByte(String columnName, byte x)`
`void` `updateBytes(int columnIndex, byte[] x)`
`void` `updateBytes(String columnName, byte[] x)`
`void` `updateCharacterStream(int columnIndex, Reader reader)`
`void` `updateCharacterStream(int columnIndex, Reader x, int length)`
`void` `updateCharacterStream(int columnIndex, Reader reader, long length)`
`void` `updateCharacterStream(String columnName, Reader reader)`
`void` `updateCharacterStream(String columnName, Reader reader, int length)`
`void` `updateCharacterStream(String columnName, Reader reader, long length)`
`void` `updateClob(int columnIndex, Clob x)`
`void` `updateClob(int columnIndex, Reader reader)`
`void` `updateClob(int columnIndex, Reader reader, long length)`
`void` `updateClob(String columnName, Clob x)`
`void` `updateClob(String columnName, Reader reader)`
`void` `updateClob(String columnName, Reader reader, long length)`
`void` `updateDate(int columnIndex, Date x)`
`void` `updateDate(String columnName, Date x)`
`void` `updateDouble(int columnIndex, double x)`
`void` `updateDouble(String columnName, double x)`
`void` `updateFloat(int columnIndex, float x)`
`void` `updateFloat(String columnName, float x)`
`void` `updateInt(int columnIndex, int x)`
`void` `updateInt(String columnName, int x)`
`void` `updateLong(int columnIndex, long x)`
`void` `updateLong(String columnName, long x)`
`void` `updateNCharacterStream(int columnIndex, Reader x)`
`void` `updateNCharacterStream(int columnIndex, Reader x, int length)`
`void` `updateNCharacterStream(int columnIndex, Reader x, long length)`
`void` `updateNCharacterStream(String columnName, Reader x)`
`void` `updateNCharacterStream(String columnName, Reader x, int length)`
`void` `updateNCharacterStream(String columnName, Reader x, long length)`
`void` `updateNClob(int columnIndex, NClob nClob)`
`void` `updateNClob(int columnIndex, Reader reader)`
`void` `updateNClob(int columnIndex, Reader reader, long length)`
`void` `updateNClob(String columnName, NClob nClob)`
`void` `updateNClob(String columnName, Reader reader)`
`void` `updateNClob(String columnName, Reader reader, long length)`
`void` `updateNString(int columnIndex, String nString)`
`void` `updateNString(String columnName, String nString)`
`void` `updateNull(int columnIndex)`
`void` `updateNull(String columnName)`
`void` `updateObject(int columnIndex, Object x)`
`void` `updateObject(int columnIndex, Object x, int scale)`
`void` `updateObject(int columnIndex, Object x, java.sql.SQLType targetSqlType)`
`void` `updateObject(int columnIndex, Object x, java.sql.SQLType targetSqlType, int scaleOrLength)`
`void` `updateObject(String columnName, Object x)`
`void` `updateObject(String columnName, Object x, int scale)`
`void` `updateObject(String columnLabel, Object x, java.sql.SQLType targetSqlType)`
`void` `updateObject(String columnLabel, Object x, java.sql.SQLType targetSqlType, int scaleOrLength)`
`void` `updateRef(int columnIndex, Ref x)`
`void` `updateRef(String columnName, Ref x)`
`void` `updateRow()`
`void` `updateRowId(int columnIndex, RowId x)`
`void` `updateRowId(String columnName, RowId x)`
`void` `updateShort(int columnIndex, short x)`
`void` `updateShort(String columnName, short x)`
`void` `updateSQLXML(int columnIndex, SQLXML xmlObject)`
`void` `updateSQLXML(String columnName, SQLXML xmlObject)`
`void` `updateString(int columnIndex, String x)`
`void` `updateString(String columnName, String x)`
`void` `updateTime(int columnIndex, Time x)`
`void` `updateTime(String columnName, Time x)`
`void` `updateTimestamp(int columnIndex, Timestamp x)`
`void` `updateTimestamp(String columnName, Timestamp x)`
`protected void` `updateValue(int columnIndex, Object value)`
`boolean` `wasNull()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### connection

    protected final BaseConnection connection

#### statement

    protected final BaseStatement statement

#### fields

    protected final Field[] fields

#### originalQuery

    protected final Query originalQuery

#### maxRows

    protected final int maxRows

#### maxFieldSize

    protected final int maxFieldSize

#### rows

    protected List<Tuple> rows

#### queueRows

    protected RedshiftRowsBlockingQueue<Tuple> queueRows

#### rowCount

    protected int[] rowCount

#### ringBufferThread

    protected Thread ringBufferThread

#### currentRow

    protected int currentRow

#### rowOffset

    protected int rowOffset

#### thisRow

    protected Tuple thisRow

#### warnings

    protected SQLWarning warnings

#### wasNullFlag

    protected boolean wasNullFlag

True if the last obtained column value was SQL NULL as specified by `wasNull()`. The value is always updated by the `checkResultSet(int)` method.

#### onInsertRow

    protected boolean onInsertRow

#### fetchSize

    protected int fetchSize

#### cursor

    protected ResultCursor cursor

### Method Detail

#### createMetaData

    protected ResultSetMetaData createMetaData()
                                        throws SQLException

Throws:
  `SQLException`

#### getMetaData

    public ResultSetMetaData getMetaData()
                                  throws SQLException

Specified by:
  `getMetaData` in interface `ResultSet`
Throws:
  `SQLException`

#### getRowCount

    public long getRowCount()
                     throws SQLException

Returns the number of rows in the result set. The value returned is undefined if the row count is unknown.

The value returned must fit into a 32-bit integer when targeting a 32-bit platform, or a 64-bit integer for a 64-bit platform. The value must be non-negative, except if the row count is unknown.

This is not a JDBC specification method. This is for backward compatibility only.

Returns:
  Number of rows in the result set.
Throws:
  `SQLException` - If an error occurs.

#### getURL

    public URL getURL(int columnIndex)
               throws SQLException

Specified by:
  `getURL` in interface `ResultSet`
Throws:
  `SQLException`

#### getURL

    public URL getURL(String columnName)
               throws SQLException

Specified by:
  `getURL` in interface `ResultSet`
Throws:
  `SQLException`

#### internalGetObject

    protected Object internalGetObject(int columnIndex,
                           Field field)
                                throws SQLException

Throws:
  `SQLException`

#### absolute

    public boolean absolute(int index)
                     throws SQLException

Specified by:
  `absolute` in interface `ResultSet`
Throws:
  `SQLException`

#### afterLast

    public void afterLast()
                   throws SQLException

Specified by:
  `afterLast` in interface `ResultSet`
Throws:
  `SQLException`

#### beforeFirst

    public void beforeFirst()
                     throws SQLException

Specified by:
  `beforeFirst` in interface `ResultSet`
Throws:
  `SQLException`

#### first

    public boolean first()
                  throws SQLException

Specified by:
  `first` in interface `ResultSet`
Throws:
  `SQLException`

#### getArray

    public Array getArray(String colName)
                   throws SQLException

Specified by:
  `getArray` in interface `ResultSet`
Throws:
  `SQLException`

#### makeArray

    protected Array makeArray(int oid,
                  byte[] value)
                       throws SQLException

Throws:
  `SQLException`

#### makeArray

    protected Array makeArray(int oid,
                  String value)
                       throws SQLException

Throws:
  `SQLException`

#### getArray

    public Array getArray(int i)
                   throws SQLException

Specified by:
  `getArray` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex)
                             throws SQLException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal(String columnName)
                             throws SQLException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getBlob

    public Blob getBlob(String columnName)
                 throws SQLException

Specified by:
  `getBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### makeBlob

    protected Blob makeBlob(long oid)
                     throws SQLException

Throws:
  `SQLException`

#### getBlob

    public Blob getBlob(int i)
                 throws SQLException

Specified by:
  `getBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### getCharacterStream

    public Reader getCharacterStream(String columnName)
                              throws SQLException

Specified by:
  `getCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getCharacterStream

    public Reader getCharacterStream(int i)
                              throws SQLException

Specified by:
  `getCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getClob

    public Clob getClob(String columnName)
                 throws SQLException

Specified by:
  `getClob` in interface `ResultSet`
Throws:
  `SQLException`

#### makeClob

    protected Clob makeClob(long oid)
                     throws SQLException

Throws:
  `SQLException`

#### getClob

    public Clob getClob(int i)
                 throws SQLException

Specified by:
  `getClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getConcurrency

    public int getConcurrency()
                       throws SQLException

Specified by:
  `getConcurrency` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public Date getDate(int i,
               Calendar cal)
                 throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public Time getTime(int i,
               Calendar cal)
                 throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public Timestamp getTimestamp(int i,
                         Calendar cal)
                           throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public Date getDate(String c,
               Calendar cal)
                 throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public Time getTime(String c,
               Calendar cal)
                 throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public Timestamp getTimestamp(String c,
                         Calendar cal)
                           throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

Specified by:
  `getFetchDirection` in interface `ResultSet`
Throws:
  `SQLException`

#### getObjectImpl

    public Object getObjectImpl(String columnName,
                       Map<String,Class<?>> map)
                         throws SQLException

Throws:
  `SQLException`

#### getObjectImpl

    public Object getObjectImpl(int i,
                       Map<String,Class<?>> map)
                         throws SQLException

Throws:
  `SQLException`

#### getRef

    public Ref getRef(String columnName)
               throws SQLException

Specified by:
  `getRef` in interface `ResultSet`
Throws:
  `SQLException`

#### getRef

    public Ref getRef(int i)
               throws SQLException

Specified by:
  `getRef` in interface `ResultSet`
Throws:
  `SQLException`

#### getRow

    public int getRow()
               throws SQLException

Specified by:
  `getRow` in interface `ResultSet`
Throws:
  `SQLException`

#### getStatement

    public Statement getStatement()
                           throws SQLException

Specified by:
  `getStatement` in interface `ResultSet`
Throws:
  `SQLException`

#### getType

    public int getType()
                throws SQLException

Specified by:
  `getType` in interface `ResultSet`
Throws:
  `SQLException`

#### isAfterLast

    public boolean isAfterLast()
                        throws SQLException

Specified by:
  `isAfterLast` in interface `ResultSet`
Throws:
  `SQLException`

#### isBeforeFirst

    public boolean isBeforeFirst()
                          throws SQLException

Specified by:
  `isBeforeFirst` in interface `ResultSet`
Throws:
  `SQLException`

#### isFirst

    public boolean isFirst()
                    throws SQLException

Specified by:
  `isFirst` in interface `ResultSet`
Throws:
  `SQLException`

#### isLast

    public boolean isLast()
                   throws SQLException

Specified by:
  `isLast` in interface `ResultSet`
Throws:
  `SQLException`

#### last

    public boolean last()
                 throws SQLException

Specified by:
  `last` in interface `ResultSet`
Throws:
  `SQLException`

#### previous

    public boolean previous()
                     throws SQLException

Specified by:
  `previous` in interface `ResultSet`
Throws:
  `SQLException`

#### relative

    public boolean relative(int rows)
                     throws SQLException

Specified by:
  `relative` in interface `ResultSet`
Throws:
  `SQLException`

#### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

Specified by:
  `setFetchDirection` in interface `ResultSet`
Throws:
  `SQLException`

#### cancelRowUpdates

    public void cancelRowUpdates()
                          throws SQLException

Specified by:
  `cancelRowUpdates` in interface `ResultSet`
Throws:
  `SQLException`

#### deleteRow

    public void deleteRow()
                   throws SQLException

Specified by:
  `deleteRow` in interface `ResultSet`
Throws:
  `SQLException`

#### insertRow

    public void insertRow()
                   throws SQLException

Specified by:
  `insertRow` in interface `ResultSet`
Throws:
  `SQLException`

#### moveToCurrentRow

    public void moveToCurrentRow()
                          throws SQLException

Specified by:
  `moveToCurrentRow` in interface `ResultSet`
Throws:
  `SQLException`

#### moveToInsertRow

    public void moveToInsertRow()
                         throws SQLException

Specified by:
  `moveToInsertRow` in interface `ResultSet`
Throws:
  `SQLException`

#### rowDeleted

    public boolean rowDeleted()
                       throws SQLException

Specified by:
  `rowDeleted` in interface `ResultSet`
Throws:
  `SQLException`

#### rowInserted

    public boolean rowInserted()
                        throws SQLException

Specified by:
  `rowInserted` in interface `ResultSet`
Throws:
  `SQLException`

#### rowUpdated

    public boolean rowUpdated()
                       throws SQLException

Specified by:
  `rowUpdated` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream x,
                         int length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBigDecimal

    public void updateBigDecimal(int columnIndex,
                        BigDecimal x)
                          throws SQLException

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream x,
                          int length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBoolean

    public void updateBoolean(int columnIndex,
                     boolean x)
                       throws SQLException

Specified by:
  `updateBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### updateByte

    public void updateByte(int columnIndex,
                  byte x)
                    throws SQLException

Specified by:
  `updateByte` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBytes

    public void updateBytes(int columnIndex,
                   byte[] x)
                     throws SQLException

Specified by:
  `updateBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader x,
                             int length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDate

    public void updateDate(int columnIndex,
                  Date x)
                    throws SQLException

Specified by:
  `updateDate` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDouble

    public void updateDouble(int columnIndex,
                    double x)
                      throws SQLException

Specified by:
  `updateDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### updateFloat

    public void updateFloat(int columnIndex,
                   float x)
                     throws SQLException

Specified by:
  `updateFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### updateInt

    public void updateInt(int columnIndex,
                 int x)
                   throws SQLException

Specified by:
  `updateInt` in interface `ResultSet`
Throws:
  `SQLException`

#### updateLong

    public void updateLong(int columnIndex,
                  long x)
                    throws SQLException

Specified by:
  `updateLong` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNull

    public void updateNull(int columnIndex)
                    throws SQLException

Specified by:
  `updateNull` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(int columnIndex,
                    Object x)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(int columnIndex,
                    Object x,
                    int scale)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### refreshRow

    public void refreshRow()
                    throws SQLException

Specified by:
  `refreshRow` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRow

    public void updateRow()
                   throws SQLException

Specified by:
  `updateRow` in interface `ResultSet`
Throws:
  `SQLException`

#### updateShort

    public void updateShort(int columnIndex,
                   short x)
                     throws SQLException

Specified by:
  `updateShort` in interface `ResultSet`
Throws:
  `SQLException`

#### updateString

    public void updateString(int columnIndex,
                    String x)
                      throws SQLException

Specified by:
  `updateString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTime

    public void updateTime(int columnIndex,
                  Time x)
                    throws SQLException

Specified by:
  `updateTime` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTimestamp

    public void updateTimestamp(int columnIndex,
                       Timestamp x)
                         throws SQLException

Specified by:
  `updateTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNull

    public void updateNull(String columnName)
                    throws SQLException

Specified by:
  `updateNull` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBoolean

    public void updateBoolean(String columnName,
                     boolean x)
                       throws SQLException

Specified by:
  `updateBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### updateByte

    public void updateByte(String columnName,
                  byte x)
                    throws SQLException

Specified by:
  `updateByte` in interface `ResultSet`
Throws:
  `SQLException`

#### updateShort

    public void updateShort(String columnName,
                   short x)
                     throws SQLException

Specified by:
  `updateShort` in interface `ResultSet`
Throws:
  `SQLException`

#### updateInt

    public void updateInt(String columnName,
                 int x)
                   throws SQLException

Specified by:
  `updateInt` in interface `ResultSet`
Throws:
  `SQLException`

#### updateLong

    public void updateLong(String columnName,
                  long x)
                    throws SQLException

Specified by:
  `updateLong` in interface `ResultSet`
Throws:
  `SQLException`

#### updateFloat

    public void updateFloat(String columnName,
                   float x)
                     throws SQLException

Specified by:
  `updateFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDouble

    public void updateDouble(String columnName,
                    double x)
                      throws SQLException

Specified by:
  `updateDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBigDecimal

    public void updateBigDecimal(String columnName,
                        BigDecimal x)
                          throws SQLException

Specified by:
  `updateBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### updateString

    public void updateString(String columnName,
                    String x)
                      throws SQLException

Specified by:
  `updateString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBytes

    public void updateBytes(String columnName,
                   byte[] x)
                     throws SQLException

Specified by:
  `updateBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### updateDate

    public void updateDate(String columnName,
                  Date x)
                    throws SQLException

Specified by:
  `updateDate` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTime

    public void updateTime(String columnName,
                  Time x)
                    throws SQLException

Specified by:
  `updateTime` in interface `ResultSet`
Throws:
  `SQLException`

#### updateTimestamp

    public void updateTimestamp(String columnName,
                       Timestamp x)
                         throws SQLException

Specified by:
  `updateTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(String columnName,
                         InputStream x,
                         int length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(String columnName,
                          InputStream x,
                          int length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(String columnName,
                             Reader reader,
                             int length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(String columnName,
                    Object x,
                    int scale)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(String columnName,
                    Object x)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### quotelessTableName

    public static String[] quotelessTableName(String fullname)

Cracks out the table name and schema (if it exists) from a fully qualified table name.

Parameters:
  `fullname` - string that we are trying to crack. Test cases:

                       Table: table
                                       ()

                       "Table": Table
                                       ()

                       Schema.Table:
                                       table (schema)

                                       "Schema"."Table": Table
                                                       (Schema)

                                       "Schema"."Dot.Table": Dot.Table
                                                       (Schema)

                                       Schema."Dot.Table": Dot.Table
                                                       (schema)

Returns:
  String array with element zero always being the tablename and element 1 the schema name which may be a zero length string.

#### getRedshiftStatement

    public BaseStatement getRedshiftStatement()

#### getRefCursor

    public String getRefCursor()

Specified by:
  `getRefCursor` in interface `RedshiftRefCursorResultSet`
Returns:
  the name of the cursor.

#### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

Specified by:
  `setFetchSize` in interface `ResultSet`
Throws:
  `SQLException`

#### getFetchSize

    public int getFetchSize()
                     throws SQLException

Specified by:
  `getFetchSize` in interface `ResultSet`
Throws:
  `SQLException`

#### next

    public boolean next()
                 throws SQLException

Specified by:
  `next` in interface `ResultSet`
Throws:
  `SQLException`

#### close

    public void close()
               throws SQLException

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `ResultSet`
Throws:
  `SQLException`

#### closeInternally

    protected void closeInternally()
                            throws SQLException

Throws:
  `SQLException`

#### wasNull

    public boolean wasNull()
                    throws SQLException

Specified by:
  `wasNull` in interface `ResultSet`
Throws:
  `SQLException`

#### getString

    public String getString(int columnIndex)
                     throws SQLException

Specified by:
  `getString` in interface `ResultSet`
Throws:
  `SQLException`

#### getBoolean

    public boolean getBoolean(int columnIndex)
                       throws SQLException

Retrieves the value of the designated column in the current row of this `ResultSet` object as a `boolean` in the Java programming language.

If the designated column has a Character datatype and is one of the following values: "1", "true", "t", "yes", "y" or "on", a value of `true` is returned. If the designated column has a Character datatype and is one of the following values: "0", "false", "f", "no", "n" or "off", a value of `false` is returned. Leading or trailing whitespace is ignored, and case does not matter.

If the designated column has a Numeric datatype and is a 1, a value of `true` is returned. If the designated column has a Numeric datatype and is a 0, a value of `false` is returned.

Specified by:
  `getBoolean` in interface `ResultSet`
Parameters:
  `columnIndex` - the first column is 1, the second is 2, ...
Returns:
  the column value; if the value is SQL `NULL`, the value returned is `false`
Throws:
  `SQLException` - if the columnIndex is not valid; if a database access error occurs; if this method is called on a closed result set or is an invalid cast to boolean type.
See Also:
  PostgreSQL Boolean Type

#### getByte

    public byte getByte(int columnIndex)
                 throws SQLException

Specified by:
  `getByte` in interface `ResultSet`
Throws:
  `SQLException`

#### getShort

    public short getShort(int columnIndex)
                   throws SQLException

Specified by:
  `getShort` in interface `ResultSet`
Throws:
  `SQLException`

#### getInt

    public int getInt(int columnIndex)
               throws SQLException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLException`

#### getLong

    public long getLong(int columnIndex)
                 throws SQLException

Specified by:
  `getLong` in interface `ResultSet`
Throws:
  `SQLException`

#### getFloat

    public float getFloat(int columnIndex)
                   throws SQLException

Specified by:
  `getFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### getDouble

    public double getDouble(int columnIndex)
                     throws SQLException

Specified by:
  `getDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal(int columnIndex,
                           int scale)
                             throws SQLException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getBytes

    public byte[] getBytes(int columnIndex)
                    throws SQLException

In normal use, the bytes represent the raw values returned by the backend. However, if the column is an OID, then it is assumed to refer to a Large Object, and that object is returned as a byte array.

Be warned If the large object is huge, then you may run out of memory.

Specified by:
  `getBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public Date getDate(int columnIndex)
                 throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public Time getTime(int columnIndex)
                 throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public Timestamp getTimestamp(int columnIndex)
                           throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getAsciiStream

    public InputStream getAsciiStream(int columnIndex)
                               throws SQLException

Specified by:
  `getAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getUnicodeStream

    public InputStream getUnicodeStream(int columnIndex)
                                 throws SQLException

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getBinaryStream

    public InputStream getBinaryStream(int columnIndex)
                                throws SQLException

Specified by:
  `getBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getString

    public String getString(String columnName)
                     throws SQLException

Specified by:
  `getString` in interface `ResultSet`
Throws:
  `SQLException`

#### getBoolean

    public boolean getBoolean(String columnName)
                       throws SQLException

Specified by:
  `getBoolean` in interface `ResultSet`
Throws:
  `SQLException`

#### getByte

    public byte getByte(String columnName)
                 throws SQLException

Specified by:
  `getByte` in interface `ResultSet`
Throws:
  `SQLException`

#### getShort

    public short getShort(String columnName)
                   throws SQLException

Specified by:
  `getShort` in interface `ResultSet`
Throws:
  `SQLException`

#### getInt

    public int getInt(String columnName)
               throws SQLException

Specified by:
  `getInt` in interface `ResultSet`
Throws:
  `SQLException`

#### getLong

    public long getLong(String columnName)
                 throws SQLException

Specified by:
  `getLong` in interface `ResultSet`
Throws:
  `SQLException`

#### getFloat

    public float getFloat(String columnName)
                   throws SQLException

Specified by:
  `getFloat` in interface `ResultSet`
Throws:
  `SQLException`

#### getDouble

    public double getDouble(String columnName)
                     throws SQLException

Specified by:
  `getDouble` in interface `ResultSet`
Throws:
  `SQLException`

#### getBigDecimal

    public BigDecimal getBigDecimal(String columnName,
                           int scale)
                             throws SQLException

Specified by:
  `getBigDecimal` in interface `ResultSet`
Throws:
  `SQLException`

#### getBytes

    public byte[] getBytes(String columnName)
                    throws SQLException

Specified by:
  `getBytes` in interface `ResultSet`
Throws:
  `SQLException`

#### getDate

    public Date getDate(String columnName)
                 throws SQLException

Specified by:
  `getDate` in interface `ResultSet`
Throws:
  `SQLException`

#### getTime

    public Time getTime(String columnName)
                 throws SQLException

Specified by:
  `getTime` in interface `ResultSet`
Throws:
  `SQLException`

#### getTimestamp

    public Timestamp getTimestamp(String columnName)
                           throws SQLException

Specified by:
  `getTimestamp` in interface `ResultSet`
Throws:
  `SQLException`

#### getAsciiStream

    public InputStream getAsciiStream(String columnName)
                               throws SQLException

Specified by:
  `getAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getUnicodeStream

    public InputStream getUnicodeStream(String columnName)
                                 throws SQLException

Specified by:
  `getUnicodeStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getBinaryStream

    public InputStream getBinaryStream(String columnName)
                                throws SQLException

Specified by:
  `getBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

Specified by:
  `getWarnings` in interface `ResultSet`
Throws:
  `SQLException`

#### clearWarnings

    public void clearWarnings()
                       throws SQLException

Specified by:
  `clearWarnings` in interface `ResultSet`
Throws:
  `SQLException`

#### addWarning

    protected void addWarning(SQLWarning warnings)

#### getCursorName

    public String getCursorName()
                         throws SQLException

Specified by:
  `getCursorName` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public Object getObject(int columnIndex)
                     throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public Object getObject(String columnName)
                     throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### findColumn

    public int findColumn(String columnName)
                   throws SQLException

Specified by:
  `findColumn` in interface `ResultSet`
Throws:
  `SQLException`

#### createColumnNameIndexMap

    public static Map<String,Integer> createColumnNameIndexMap(Field[] fields,
                                               boolean isSanitiserDisabled)

#### getColumnOID

    public int getColumnOID(int field)

Returns the OID of a field. It is used internally by the driver.

Parameters:
  `field` - field index
Returns:
  OID of a field

#### getFixedString

    public String getFixedString(int col)
                          throws SQLException

This is used to fix get*() methods on Money fields. It should only be used by those methods!

It converts ($##.##) to -##.## and $##.## to ##.##

Parameters:
  `col` - column position (1-based)
Returns:
  numeric-parsable representation of money string literal
Throws:
  `SQLException` - if something wrong happens

#### getRSType

    protected String getRSType(int column)
                        throws SQLException

Throws:
  `SQLException`

#### getSQLType

    protected int getSQLType(int column)
                      throws SQLException

Throws:
  `SQLException`

#### checkClosed

    protected void checkClosed()
                        throws SQLException

Throws:
  `SQLException`

#### isResultSetClosed

    protected boolean isResultSetClosed()

#### checkColumnIndex

    protected void checkColumnIndex(int column)
                             throws SQLException

Throws:
  `SQLException`

#### checkResultSet

    protected void checkResultSet(int column)
                           throws SQLException

Checks that the result set is not closed, it's positioned on a valid row and that the given column number is valid. Also updates the `wasNullFlag` to correct value.

Parameters:
  `column` - The column number to check. Range starts from 1.
Throws:
  `SQLException` - If state or column is invalid.

#### isBinary

    protected boolean isBinary(int column)

Returns true if the value of the given column is in binary format.

Parameters:
  `column` - The column to check. Range starts from 1.
Returns:
  True if the column is in binary format.

#### isGeometry

    protected boolean isGeometry(int column)

#### isGeometryHex

    protected boolean isGeometryHex(int column)

#### isSuper

    protected boolean isSuper(int column)

#### isVarbyte

    protected boolean isVarbyte(int column)

#### isGeography

    protected boolean isGeography(int column)

#### isInterval

    protected boolean isInterval(int column)

#### toShort

    public static short toShort(String s)
                         throws SQLException

Throws:
  `SQLException`

#### toInt

    public static int toInt(String s)
                     throws SQLException

Throws:
  `SQLException`

#### toLong

    public static long toLong(String s)
                       throws SQLException

Throws:
  `SQLException`

#### toBigDecimal

    public static BigDecimal toBigDecimal(String s)
                                   throws SQLException

Throws:
  `SQLException`

#### toBigDecimal

    public BigDecimal toBigDecimal(String s,
                          int scale)
                            throws SQLException

Throws:
  `SQLException`

#### toFloat

    public static float toFloat(String s)
                         throws SQLException

Throws:
  `SQLException`

#### toDouble

    public static double toDouble(String s)
                           throws SQLException

Throws:
  `SQLException`

#### updateValue

    protected void updateValue(int columnIndex,
                   Object value)
                        throws SQLException

Throws:
  `SQLException`

#### getUUID

    protected Object getUUID(String data)
                      throws SQLException

Throws:
  `SQLException`

#### getUUID

    protected Object getUUID(byte[] data)
                      throws SQLException

Throws:
  `SQLException`

#### updateRef

    public void updateRef(int columnIndex,
                 Ref x)
                   throws SQLException

Specified by:
  `updateRef` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRef

    public void updateRef(String columnName,
                 Ref x)
                   throws SQLException

Specified by:
  `updateRef` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob(int columnIndex,
                  Blob x)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob(String columnName,
                  Blob x)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob(int columnIndex,
                  Clob x)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob(String columnName,
                  Clob x)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateArray

    public void updateArray(int columnIndex,
                   Array x)
                     throws SQLException

Specified by:
  `updateArray` in interface `ResultSet`
Throws:
  `SQLException`

#### updateArray

    public void updateArray(String columnName,
                   Array x)
                     throws SQLException

Specified by:
  `updateArray` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public <T> T getObject(int columnIndex,
                  Class<T> type)
                throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public <T> T getObject(String columnLabel,
                  Class<T> type)
                throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public Object getObject(String s,
                   Map<String,Class<?>> map)
                     throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getObject

    public Object getObject(int i,
                   Map<String,Class<?>> map)
                     throws SQLException

Specified by:
  `getObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(int columnIndex,
                    Object x,
                    java.sql.SQLType targetSqlType,
                    int scaleOrLength)
                      throws SQLException

Throws:
  `SQLException`

#### updateObject

    public void updateObject(String columnLabel,
                    Object x,
                    java.sql.SQLType targetSqlType,
                    int scaleOrLength)
                      throws SQLException

Throws:
  `SQLException`

#### updateObject

    public void updateObject(int columnIndex,
                    Object x,
                    java.sql.SQLType targetSqlType)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### updateObject

    public void updateObject(String columnLabel,
                    Object x,
                    java.sql.SQLType targetSqlType)
                      throws SQLException

Specified by:
  `updateObject` in interface `ResultSet`
Throws:
  `SQLException`

#### getRowId

    public RowId getRowId(int columnIndex)
                   throws SQLException

Specified by:
  `getRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### getRowId

    public RowId getRowId(String columnName)
                   throws SQLException

Specified by:
  `getRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRowId

    public void updateRowId(int columnIndex,
                   RowId x)
                     throws SQLException

Specified by:
  `updateRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### updateRowId

    public void updateRowId(String columnName,
                   RowId x)
                     throws SQLException

Specified by:
  `updateRowId` in interface `ResultSet`
Throws:
  `SQLException`

#### getHoldability

    public int getHoldability()
                       throws SQLException

Specified by:
  `getHoldability` in interface `ResultSet`
Throws:
  `SQLException`

#### isClosed

    public boolean isClosed()
                     throws SQLException

Specified by:
  `isClosed` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNString

    public void updateNString(int columnIndex,
                     String nString)
                       throws SQLException

Specified by:
  `updateNString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNString

    public void updateNString(String columnName,
                     String nString)
                       throws SQLException

Specified by:
  `updateNString` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(int columnIndex,
                   NClob nClob)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(String columnName,
                   NClob nClob)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(int columnIndex,
                   Reader reader)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(String columnName,
                   Reader reader)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(int columnIndex,
                   Reader reader,
                   long length)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNClob

    public void updateNClob(String columnName,
                   Reader reader,
                   long length)
                     throws SQLException

Specified by:
  `updateNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getNClob

    public NClob getNClob(int columnIndex)
                   throws SQLException

Specified by:
  `getNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getNClob

    public NClob getNClob(String columnName)
                   throws SQLException

Specified by:
  `getNClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob(int columnIndex,
                  InputStream inputStream,
                  long length)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob(String columnName,
                  InputStream inputStream,
                  long length)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob(int columnIndex,
                  InputStream inputStream)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBlob

    public void updateBlob(String columnName,
                  InputStream inputStream)
                    throws SQLException

Specified by:
  `updateBlob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob(int columnIndex,
                  Reader reader,
                  long length)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob(String columnName,
                  Reader reader,
                  long length)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob(int columnIndex,
                  Reader reader)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### updateClob

    public void updateClob(String columnName,
                  Reader reader)
                    throws SQLException

Specified by:
  `updateClob` in interface `ResultSet`
Throws:
  `SQLException`

#### getSQLXML

    public SQLXML getSQLXML(int columnIndex)
                     throws SQLException

Specified by:
  `getSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### getSQLXML

    public SQLXML getSQLXML(String columnName)
                     throws SQLException

Specified by:
  `getSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### updateSQLXML

    public void updateSQLXML(int columnIndex,
                    SQLXML xmlObject)
                      throws SQLException

Specified by:
  `updateSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### updateSQLXML

    public void updateSQLXML(String columnName,
                    SQLXML xmlObject)
                      throws SQLException

Specified by:
  `updateSQLXML` in interface `ResultSet`
Throws:
  `SQLException`

#### getNString

    public String getNString(int columnIndex)
                      throws SQLException

Specified by:
  `getNString` in interface `ResultSet`
Throws:
  `SQLException`

#### getNString

    public String getNString(String columnName)
                      throws SQLException

Specified by:
  `getNString` in interface `ResultSet`
Throws:
  `SQLException`

#### getNCharacterStream

    public Reader getNCharacterStream(int columnIndex)
                               throws SQLException

Specified by:
  `getNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### getNCharacterStream

    public Reader getNCharacterStream(String columnName)
                               throws SQLException

Specified by:
  `getNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(int columnIndex,
                              Reader x,
                              int length)
                                throws SQLException

Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(String columnName,
                              Reader x,
                              int length)
                                throws SQLException

Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(int columnIndex,
                              Reader x)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(String columnName,
                              Reader x)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(int columnIndex,
                              Reader x,
                              long length)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateNCharacterStream

    public void updateNCharacterStream(String columnName,
                              Reader x,
                              long length)
                                throws SQLException

Specified by:
  `updateNCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader reader,
                             long length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(String columnName,
                             Reader reader,
                             long length)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(int columnIndex,
                             Reader reader)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateCharacterStream

    public void updateCharacterStream(String columnName,
                             Reader reader)
                               throws SQLException

Specified by:
  `updateCharacterStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream inputStream,
                          long length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(String columnName,
                          InputStream inputStream,
                          long length)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(int columnIndex,
                          InputStream inputStream)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateBinaryStream

    public void updateBinaryStream(String columnName,
                          InputStream inputStream)
                            throws SQLException

Specified by:
  `updateBinaryStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream inputStream,
                         long length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(String columnName,
                         InputStream inputStream,
                         long length)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(int columnIndex,
                         InputStream inputStream)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### updateAsciiStream

    public void updateAsciiStream(String columnName,
                         InputStream inputStream)
                           throws SQLException

Specified by:
  `updateAsciiStream` in interface `ResultSet`
Throws:
  `SQLException`

#### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

Specified by:
  `isWrapperFor` in interface `Wrapper`
Throws:
  `SQLException`

#### unwrap

    public <T> T unwrap(Class<T> iface)
             throws SQLException

Specified by:
  `unwrap` in interface `Wrapper`
Throws:
  `SQLException`